' SMBC workaround for offline gaming - by SMBC Hacker. Enjoy!

Module SMBCServ
  Const BufferSize As Integer = 4096
  Dim Listener As New System.Net.Sockets.TcpListener(System.Net.IPAddress.Loopback, 80)
  Dim ContentTypes As New System.Collections.Generic.Dictionary(Of String, String)(System.StringComparer.OrdinalIgnoreCase)

  Sub Main()
    ' SmbcPreloader expects valid content-types.
    ContentTypes(".gz") = "application/x-gzip"
    ContentTypes(".xml") = "application/xml"
    ContentTypes(".swf") = "application/x-shockwave-flash"
    ContentTypes(".htm") = "text/html"
    ContentTypes(".html") = "text/html"

    Listener.Start()

    Do
      Dim Client As System.Net.Sockets.TcpClient = Listener.AcceptTcpClient
      Dim Thread As New System.Threading.Thread(AddressOf Callback)

      Thread.Start(Client)
    Loop
  End Sub

  Sub Callback(ByVal Client As Object)
    Dim Stream As System.IO.Stream
    Dim Input As System.IO.StreamReader
    Dim Output As System.IO.StreamWriter

    Try
      With DirectCast(Client, System.Net.Sockets.TcpClient)
        Stream = .GetStream

        Input = New System.IO.StreamReader(Stream)
        Output = New System.IO.StreamWriter(Stream)

        Dim Match As System.Text.RegularExpressions.Match = System.Text.RegularExpressions.Regex.Match(Input.ReadLine, "^(\S+) (\S+) (\S+)$")

        If Match.Success = False Then Throw New System.Exception("Request was malformed.")

        Dim Method As String = Match.Groups(1).Value
        Dim URL As String = Match.Groups(2).Value
        Dim HTTPVer As String = Match.Groups(3).Value

        Dim Headers As New System.Collections.Generic.Dictionary(Of String, String)(System.StringComparer.OrdinalIgnoreCase)
        Dim Regex As New System.Text.RegularExpressions.Regex("^(\S+):(.*)$")

        Do
          Dim s As String = Input.ReadLine
          If s = String.Empty Then Exit Do

          Match = Regex.Match(s)

          If Match.Success = False Then Throw New System.Exception("Something was wrong with request headers.")

          Headers(Match.Groups(1).Value) = Match.Groups(2).Value.Trim
        Loop

        System.Console.WriteLine("  {0} {1} {2}", Method, URL, HTTPVer)

        For Each Item As System.Collections.Generic.KeyValuePair(Of String, String) In Headers
          System.Console.WriteLine("  {0}: {1}", Item.Key, Item.Value)
        Next

        System.Console.WriteLine()

        Dim Filename As String = System.IO.Path.GetFileName(URL)

        If Filename = String.Empty Then
          Output.WriteLine("{0} 301 Moved Permanently", HTTPVer)
          Output.WriteLine("Location: index.html")
          Output.WriteLine()

        ElseIf System.IO.File.Exists(Filename) Then
          Dim File As System.IO.Stream = New System.IO.FileStream(Filename, System.IO.FileMode.Open, System.IO.FileAccess.Read)
          Dim Extension As String = System.IO.Path.GetExtension(Filename)

          Output.WriteLine("{0} 200 OK", HTTPVer)
          Output.WriteLine("Content-Length: {0:d}", File.Length)

          If ContentTypes.ContainsKey(Extension) Then
            Output.WriteLine("Content-Type: {0}", ContentTypes(Extension))
          Else
            Output.WriteLine("Content-Type: application/octet-stream")
          End If

          Output.WriteLine()
          Output.Flush()

          Try ' client may not get the response body
            Dim Bytes As Integer = CInt(File.Length)
            Dim Buffer(BufferSize - 1) As Byte

            While Bytes > BufferSize
              File.Read(Buffer, 0, BufferSize)
              Stream.Write(Buffer, 0, BufferSize)
              Bytes -= BufferSize
              System.Console.Write("{0} sending... {1:d}" & Microsoft.VisualBasic.Chr(13), Filename, File.Position)
            End While

            File.Read(Buffer, 0, Bytes)
            Stream.Write(Buffer, 0, Bytes)
          Catch
            ' nothing here
          End Try

          System.Console.WriteLine("{0} delivered.           ", Filename)
          System.Console.WriteLine()

          File.Close()
        Else
          Output.WriteLine("{0} 404 Not Found", HTTPVer)
          Output.WriteLine()
        End If

        Output.Close() ' Automatic flush
      End With
    Catch ex As System.Exception
      System.Console.WriteLine(ex)
    End Try
  End Sub
End Module

' As you can see, there is no badware.